using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;

namespace dobriPravougaonici
{
    class Program
    {
        static bool Pravougaonik(int[] x,int[] y, int brt )
        {
            bool uslov = true;
            int sirina = x[brt - 1] - x[0] + 1;
            int duzina = y[brt - 1] - y[0] + 1;
            int duzpr = sirina*duzina;
            int brojac = 0;
            if (duzpr == brt)
            {
                for (int i = x[0]; i < x[0] + sirina; i++)
                {
                    for (int j = y[0]; j < y[0] + duzina; j++)
                    {
                        if ((x[brojac]) != i || y[brojac] != j)
                        {
                            uslov = false;
                        }
                        brojac++;
                    }
                }
            }
            else
                uslov = false;

            return uslov;
        }


        static void Main(string[] args)
        {
            //prvi red ulaza
            string[] ulaz1 = Console.ReadLine().Split();
            int n = Convert.ToInt32(ulaz1[0]);
            int k = Convert.ToInt32(ulaz1[1]);

            //ostali redovi ulaza
            string[] ulaz2 = new string[n];
            int[,] mat = new int[n,n];
            for(int i = 0; i < n; i++)
            {
                ulaz2 = Console.ReadLine().Split();
                for (int j = 0; j < n; j++)
                {
                    mat[i,j]= Convert.ToInt32(ulaz2[j]);
                }
            }

            //provera pogodnosti
            int rez = 0;
            for(int brs = 0; brs < k; brs++)//brs = broj sorte
            {
                int[] prva = new int[n*n];
                int[] druga = new int[n*n];
                int brt = 0;//broj tacnih
                for (int i = 0; i < n; i++)
                {
                    for (int j = 0; j < n; j++)
                    {
                        if (mat[i, j] == brs)
                        {
                            prva[brt] = i;
                            druga[brt] = j;
                            brt++;
                        }
                    }
                }
                if (brt > 0)
                {
                    if (Pravougaonik(prva, druga, brt) == true)
                    {
                        rez++;
                    }
                }
            }

            //izlaz
            Console.WriteLine(rez);

            Console.ReadLine();
        }
    }
}